final_project/movies/urls.py
from django.urls import path
from . import views

app_name = "movies"

urlpatterns=[
    path('', views.first_page, name='first_page'),
    path('chajja/', views.index, name="index"),
    path('movie_create/', views.movie_create, name='movie_create'),
    path('<int:movie_pk>/delete', views.movie_delete, name='movie_delete'),
    path('<int:movie_pk>/update', views.movie_update, name='movie_update'),
    path('<int:movie_pk>/', views.detail, name='detail'),
    path('<int:movie_pk>/rank/', views.rank, name='rank'),
    path('<int:movie_pk>/rank_cancle/', views.rank_cancle, name='rank_cancle'),
    path('<int:movie_pk>/review_create/', views.review_create, name='review_create'),
    path('<int:movie_pk>/<int:review_pk>/', views.review_detail, name='review_detail'),
    path('<int:movie_pk>/<int:review_pk>/update', views.review_update, name='review_update'),
    path('<int:movie_pk>/<int:review_pk>/delete', views.review_delete, name='review_delete'),
    path('<int:movie_pk>/<int:review_pk>/comments', views.comment_create, name='comment_create'),
    path('<int:movie_pk>/<int:review_pk>/<int:comment_pk>/comment_update', views.comment_update, name='comment_update'),
    path('<int:movie_pk>/<int:review_pk>/<int:comment_pk>/comment_delete', views.comment_delete, name='comment_delete'),
    # path('<int:movie_pk>/rank', views.rank, name='rank')



]

final_project/movies/models.py
from django.db import models
from django.conf import settings

# Create your models here.
class Genre(models.Model):
    name = models.CharField(max_length=100)


class Movie(models.Model):
    adult = models.BooleanField()
    backdrop_path = models.CharField(max_length=500, null=True)
    genres = models.ManyToManyField(Genre, related_name='movie_genre')
    original_language = models.CharField(max_length=20)
    original_title = models.CharField(max_length=200)
    overview = models.TextField(null=True)
    popularity = models.FloatField(null=True)
    poster_path = models.CharField(max_length=500, null=True)
    release_date = models.DateField(null=True)
    title = models.CharField(max_length=200)
    vote_average = models.FloatField(null=True)
    vote_count = models.IntegerField(null=True)
    vote_user = models.ManyToManyField(settings.AUTH_USER_MODEL, related_name="vote_movie", blank=True)
    

class Review(models.Model):
    title = models.CharField(max_length=100)
    movie = models.ForeignKey(Movie, on_delete=models.CASCADE)
    content = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)
    user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE)
    

class Comment(models.Model):
    comment = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)
    user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE)
    review = models.ForeignKey(Review, on_delete=models.CASCADE)

class Rate(models.Model):
    rank = models.IntegerField()
    user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE)
    movie = models.ForeignKey(Movie, on_delete=models.CASCADE)

final_project/movies/forms.py
from django import forms
from .models import *

class ReviewForm(forms.ModelForm):
    class Meta:
        model = Review
        fields = ['title', 'content']


class CommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ['comment']

class RatingForm(forms.ModelForm):
    class Meta:
        model = Rate
        fields = ['rank']

class MovieForm(forms.ModelForm):
    class Meta:
        model = Movie
        fields = '__all__'

final_project/movies/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.views.decorators.http import require_POST
from django.contrib.auth.decorators import login_required
from django.contrib.auth import get_user_model
# 슈퍼유저인지 알아보기 위한 데코레이터
from django.contrib.auth.decorators import user_passes_test

import random

from .models import *
from .forms import *

from django.db.models import Q
# 슈퍼유저인지 알아보기 위한 데코레이터

def first_page(request):
    pass
    return render(request, 'movies/first_page.html')

def index(request):
    movies = Movie.objects.all()
    # fr_movies = Movie.objects.all().exclude(poster_path__isnull=True).exclude(backdrop_path__isnull=True).order_by('-popularity')[:21]
    # en_movies = Movie.objects.all().exclude(poster_path__isnull=True).exclude(backdrop_path__isnull=True).order_by('-vote_average')[:21]
    fr_movies = Movie.objects.all().exclude(poster_path__isnull=True).exclude(backdrop_path__isnull=True).filter(popularity__gte=20).order_by('?')[:21]
    en_movies = Movie.objects.all().exclude(poster_path__isnull=True).exclude(backdrop_path__isnull=True).filter(vote_average__gte=8).order_by('?')[:21]
    lists = {fr_movies:'인기 많은 영화',  en_movies:'평점 높은 영화'}
    ### 유저가 투표한 장르의 영화들을 가져옴###
    user_movie = Movie.objects.all().filter(vote_user=request.user.id)
    # 영화들이 쿼리셋형태라 mv로 각각의 요소를 가져올 것임
    gen_list = {} # 나의 장르 리스트 // 평점을 표현한 영화의 장르들의 목록. 어떤 장르를 몇개 투표했는지 알기 위해
    for mv in user_movie:
        ge = mv.id # 해당 영화의 id를 ge라고 선언
        gen = Genre.objects.all().filter(movie_genre=ge) # 역참조로 해당 영화에 대한 장르정보를 장르 테이블에서 가져옴 (이름 알기 위해)
        for genr in gen: # 장르 요소가 쿼리셋이어서 genr로 선언
            genre = genr.id # 해당 장르의 id를 가져옴
            if genre in gen_list: # 평점을 남긴 영화의 장르가 나의 장르 리스트에 있는지 보고
                gen_list[genre] += 1 # 있으면 1 증가
            else:
                gen_list[genre] = 1 # 없으면 만들어 줌
           
    sorted(gen_list.items(), key=lambda x: x[1], reverse=True) # 갯수 상위 순으로 출력 위해서 정렬
    
    x = 0
    recommend_list = {}
    for key, value in gen_list.items(): # 딕셔너리 형태여서 
        if x == 3: # 상위 3개만 출력하기 위해
            break
        gen_rec_m = Movie.objects.all().exclude(poster_path__isnull=True, backdrop_path__isnull=True).filter(genres = key).order_by('?')[:21] # 장르기반 추천 영화 목록// 장르기준으로 랜덤 4개 출력
        keyname = Genre.objects.all().filter(id=key) # 장르 이름을 출력해야해서, 장르id를 key로 하고
        recommend_list[keyname] = gen_rec_m # 선별한 쿼리셋을 value로 한 딕셔너리 만듬
        x += 1
       
    context = {
        'movies' : movies,
        'fr_movies': fr_movies,
        'en_movies': en_movies,
        'user_movie' : user_movie,
        'gen_list': gen_list,
        'recommend_list' : recommend_list,
        'lists':lists
    }
    return render(request, 'movies/index.html', context)

def detail(request, movie_pk):
    movie = get_object_or_404(Movie, pk=movie_pk)
    rate = Rate.objects.all().filter(user_id=request.user.id, movie_id = movie.pk)
    form = RatingForm(request.POST)
    genres = Genre.objects.all().filter(movie_genre=movie_pk)
    user = request.user
    movie_names = Movie.objects.all().filter(vote_user=request.user.id)
    point = 0
    for score in rate:
        if request.user.id == score.user_id and movie_pk == score.movie_id:
            point = int(score.rank)

    total = (movie.vote_average) * (movie.vote_count)

    context = {
    'movie':movie,
    'genres':genres,
    'total':total,
    'rate' : rate,
    'form': form,
    'user' : user,
    'point' : point,
    'movie_names':movie_names,
    }
    return render(request, 'movies/detail.html', context)

### 영화 평점넣기 ###

def rank(request, movie_pk):
    movie = get_object_or_404(Movie, pk = movie_pk)
    rate = Rate.objects.all()
    User = get_user_model()
    total = (movie.vote_average) * (movie.vote_count)
    if request.user.is_authenticated:
        if request.user not in movie.vote_user.all():
            form = RatingForm(request.POST)
            if form.is_valid():
                rate = form.save(commit=False)
                rate.user = request.user
                rate.movie = movie
                rate.save()
                movie.vote_user.add(request.user)
        else:
            pass
    return redirect('movies:detail', movie.pk)

def rank_cancle(request, movie_pk):
    global point
    movie = get_object_or_404(Movie, pk = movie_pk)
    rate =  Rate.objects.all().filter(movie_id = movie_pk, user_id = request.user.id)
    rate.delete()
    movie.vote_user.remove(request.user)
    return redirect('movies:detail', movie.pk)


### 리뷰 관련 ###
@login_required
def review_create(request, movie_pk):
    movie = get_object_or_404(Movie, pk=movie_pk)
    if request.method == "POST":
        form = ReviewForm(request.POST)
        if form.is_valid():
            review = form.save(commit=False)
            review.movie = movie
            review.user = request.user
            review.save()
            return redirect('movies:review_detail', review.movie.id, review.pk)
    else:
        form = ReviewForm()
    context = {
        'form': form,
        'movie':movie
    }
    return render(request, 'movies/review_form.html', context)


def review_detail(request, movie_pk, review_pk):
    movie = get_object_or_404(Movie, pk=movie_pk)
    review = get_object_or_404(Review, pk=review_pk)
    form = CommentForm()

    context = {
        'movie':movie,
        'review' : review,
        'form':form
    }
    return render(request, 'movies/review_detail.html', context)

@login_required
def review_update(request, movie_pk, review_pk):
    movie = get_object_or_404(Movie, pk=movie_pk)
    review = get_object_or_404(Review, pk=review_pk)
    # 글작성 유저랑 로그인 한 유저가 같을 때
    if request.user == review.user:
        # POST방식일 때
        if request.method == "POST":
            form = ReviewForm(request.POST, instance=review)
            if form.is_valid():
                review = form.save(commit=False)
                review.user = request.user
                review.movie = movie
                review.save()
                # 글수정을 완료하고 review_detail페이지로 돌려줌
                return redirect('movies:review_detail', review.movie.id, review.pk)
        # GET방식일때
        else:
            form = ReviewForm(instance=review)
        context = {
            'form':form,
        }
        return render(request, 'movies/review_form.html', context)
    else:
        return redirect('movies:review_detail', review_pk, movie_pk)

@login_required
@require_POST
def review_delete(request, movie_pk, review_pk):
    movie = get_object_or_404(Movie, pk=movie_pk)
    review = get_object_or_404(Review, pk=review_pk )
    if request.user == review.user:
        review.delete()
    return redirect('movies:detail', movie.pk)

### Comment 관련 ###

@require_POST
def comment_create(request, movie_pk, review_pk):
    if request.user.is_authenticated:
        movie = get_object_or_404(Movie, pk=movie_pk)
        review = get_object_or_404(Review, pk=review_pk)
        form = CommentForm(request.POST)
        if form.is_valid():
            comment = form.save(commit=False)
            comment.user = request.user
            comment.review = review
            comment.save()
    return redirect('movies:review_detail', movie.pk, review.pk)

@login_required
def comment_update(request, movie_pk, review_pk, comment_pk):
    movie = get_object_or_404(Movie, pk=movie_pk)
    review = get_object_or_404(Review, pk=review_pk)
    comment = get_object_or_404(Comment, pk=comment_pk)
    # 글작성 유저랑 로그인 한 유저가 같을 때
    if request.user == comment.user:
        # POST방식일 때
        if request.method == "POST":
            form = CommentForm(request.POST, instance=comment)
            if form.is_valid():
                comment = form.save(commit=False)
                comment.user = request.user
                comment.movie = movie
                comment.save()
                # 글수정을 완료하고 review_detail페이지로 돌려줌
                return redirect('movies:review_detail', review.movie.id, review.pk)
        # GET방식일때
        else:
            form = CommentForm(instance=comment)
        context = {
            'form':form,
        }
        return render(request, 'movies/review_form.html', context)
    else:
        return redirect('movies:review_detail', review_pk, movie_pk)

@login_required
@require_POST
def comment_delete(request, movie_pk, review_pk, comment_pk):
    movie = get_object_or_404(Movie, pk=movie_pk)
    review = get_object_or_404(Review, pk=review_pk)
    comment = get_object_or_404(Comment, pk=comment_pk)
    if request.user == comment.user:
        comment.delete()  
    return redirect('movies:review_detail', movie.pk, review.pk)

### 관리자 관련 (슈퍼유저인지 아닌지에 따른 영화 쓰기) ###
@user_passes_test(lambda u: u.is_superuser)
def movie_create(request):
    if request.method == "POST":
        form = MovieForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect('movies:index')

    else:
        form = MovieForm()

    context = {
        'form' : form
    }
    return render(request, 'movies/m_cre_upd.html', context)

@user_passes_test(lambda u : u.is_superuser)
@login_required
def movie_delete(request, movie_pk):
    movie = get_object_or_404(Movie, pk=movie_pk)
    movie.delete()

    return redirect('movies:index')

@user_passes_test(lambda u: u.is_superuser)
@login_required
def movie_update(request, movie_pk):
    movie = get_object_or_404(Movie, pk=movie_pk)
    if request.method == 'POST':
        form = MovieForm(request.POST, instance=movie)
        if form.is_valid():
            form.save()
            return redirect('movies:index', movie_pk)
    else:
        form = MovieForm(instance=movie)
    context = {
        'form': form
    }
    return render(request, 'movies/m_cre_upd.html', context)

final_project/movies/templates/movies/detail.html
{% extends 'base.html' %}
{% load bootstrap4 %}
{% load static %}


{% block content %}
<div class='detail_page'>
    <div class="flex-left ml-5" style='padding-top: 30px;'>
        <a href="{% url 'movies:index' %}"><i class="fas fa-arrow-left fa-2x" style='color: tomato'></i></a>
    </div>
   
    <!-- title -->
    <h1 class="doh-font text-center mb-5" style="font-size:3rem; position: relative; z-index: 2;">{{movie.original_title}}</h1>
    <div class='container'>
        <div class='row'>
            <div class='col-12 col-lg-6 align-items-center mb-5'>
                <img class='w-100' style='height:300px;' src="https://image.tmdb.org/t/p/original/{{movie.backdrop_path}}" alt="">
            </div>
            <div class='col-12 col-lg-6 align-items-center font-weight-bold'>
                <h5 class="doh-font" style='font-size: 2rem; margin-bottom: 1rem;'>영화 소개</h5> 
                <hr class="mt-2 mb-3 my-hr">
                <span class="d-block">
                    <p class='overview1'>{{movie.overview}}</p>
                </span>
                
                <p class='mt-3'>개봉일 : {{movie.release_date}}</p>
                <p>평점 : {{movie.vote_average}}</p>
                {% for genre in genres %}
                <p>장르 : {{ genre.name }} </p>
                {% endfor %}
                <div class="mt-2"><p>나의 평점 : {{ point }} 점</p></div>
                <br>
            </div>
        </div>
    </div>

    <div class='container' style="clear:both;">
    <hr>
    <!-- 조건에 따라 등장 -->
        {% if point == 0 %}
        <form action="{% url 'movies:rank' movie.pk %}" method="POST"  style='width:150px' class='d-flex justify-content-between'>
            {% csrf_token %}
            {% bootstrap_form form %}
            <button type="submit" class="btn btn-outline-light h-100 c" style="margin-top: 37px;"><i class="fas fa-star" style='color:rgb(255, 255, 83)'></i></button>
        </form>
        {% else %}
            <a href="{% url 'movies:rank_cancle' movie.pk %}"><button type="submit" class="btn btn-light">평가취소</button></a>
        {% endif %}
        <hr> 

        <form action="" method="POST">
            {% csrf_token %}
            <a href="{% url 'movies:review_create' movie.pk %}"><button type="button" class="btn btn-outline-light c detail-button mb-1">리뷰작성</button></a>
        </form>
        
        {% if not movie.review_set.all.exists %}
            <p class='text-center' style='margin-top: 100px;' >아직 작성된 리뷰가 없습니다</p>
        {% else %}
        <table class="table text-center" style='margin-bottom: 10rem;'>
            <thead>
                <tr class="c" style="color: whitesmoke;">
                    <th style="width: 10%" scope="col">글 번호</th>
                    <th style="width: 35%" scope="col">제목</th>
                    <th style="width: 35%" scope="col">작성자</th>
                    <th style="width: 20%"scope="col">작성시간</th>
                </tr>
            </thead>
            <tbody>
                {% for review in movie.review_set.all  %}
                <tr>
                    <th scope="row">{{ forloop.counter }}</th>
                    <td><a href="{% url 'movies:review_detail' movie.pk review.pk %}">{{review.title}}</a></td>
                    <td>{{review.user}}</td>
                    <td>{{review.created_at}}</td>
                </tr>
                {% endfor %}
                {% endif %}
            </tbody>
        </table>
    </div>
    
</div>
{% endblock %}

final_project/movies/templates/movies/first_page.html
{% extends 'hello.html' %}
{% load static %}

{% block content %}
    <div style='display: flex; justify-content: center; align-items: center;' id="chajjaImage">
        <img id="chajjaImage"src="{% static 'image/first_page.png' %}" alt="사이트명_차짜">
    </div>
{% endblock %}

final_project/movies/templates/movies/genre_pick.html
{% extends 'base.html' %}

{% block content %}
    {% for m in mo %}
        {{m.title}}
        {{m.id}}    
    {% endfor %}
    <br>
    <!-- {% for gm in genre_movie %}
        {{gm}}
    {% endfor %} -->
    <br>
    {% for g in genre1 %}
        {{g}}
    {% endfor %}

    
{% endblock %}

final_project/movies/templates/movies/index.html
{% extends 'base.html' %}
{% load bootstrap4 %}
{% load static %}


{% block content %}

<div id="body">
    <div>
        {% if request.user.is_authenticated %}
        <div class="container">
            {% if recommend_list != null %}
            <h1 class="doh-font pt-5 text-center"> 회원님이 보신 장르 내 추천 </h1>
            {% endif %}
            {% for key, value in recommend_list.items %}
                {% for k in key %}
                <h1 class="f doh-font"><i class="fas fa-heart mr-3" style='color:tomato'></i>{{ k.name }}</h1>
                {% endfor %}
                <div class="row pb-4">
                    <div class="MultiCarousel" data-items="1,3,5,6" data-slide="3" id="MultiCarousel"  data-interval="1000">
                        <div class="MultiCarousel-inner">
                            {% for rec in value %}
                            {% if rec.poster_path != null and rec.backdrop_path != null %}
                            <div class="item">
                                <div class="pad15">
                                    <div class="card">
                                        <a href="{% url 'movies:detail' rec.pk %}"><img style='height: 300px;' src="https://image.tmdb.org/t/p/w342/{{rec.poster_path}}" class="card-img-top" alt=""></a>
                                    </div>
                                </div>
                            </div>
                            {% endif %}
                            {% endfor %}
                        </div>
                        <button class="btn leftLst"><i class="fas fa-chevron-left fa-3x" style='color: rgba(202, 202, 202, 0.616);'></i></button>
                        <button class="btn rightLst"><i class="fas fa-chevron-right fa-3x" style='color: rgba(202, 202, 202, 0.616);'></i></button>
                    </div>
                </div>        
            {% endfor %}
        {% endif %}
        </div>

    
        <div class="container">
            {% for key,value in lists.items %}
            <!-- <div class="container"> -->
                <h1 class="doh-font pt-5">{{value}}</h1>
                <hr align="left" style="border: solid 2px; color: whitesmoke; width:250px;">
                <div class="row pb-4">
                    <div class="MultiCarousel" data-items="1,3,5,6" data-slide="3" id="MultiCarousel"  data-interval="1000">
                        <div class="MultiCarousel-inner">
                            {% for li in key %}
                            {% if li.poster_path != null and li.backdrop_path != null %}
                            <div class="item">
                                <div class="pad15">
                                    <div class="card">
                                        <a href="{% url 'movies:detail' li.pk %}"><img style='height: 350px;' src="https://image.tmdb.org/t/p/w342/{{li.poster_path}}" class="card-img-top" alt=""></a>
                                    </div>
                                </div>
                            </div>
                            {% endif %}
                            {% endfor %}
                        </div>
                        <button class="btn leftLst"><i class="fas fa-chevron-left fa-3x" style='color: rgba(202, 202, 202, 0.616);'></i></button>
                        <button class="btn rightLst"><i class="fas fa-chevron-right fa-3x" style='color: rgba(202, 202, 202, 0.616);'></i></button>
                    </div>
                </div>
                <!-- <hr style="border: solid 2px;"> -->
            <!-- </div> -->
            {% endfor %}
        </div>
    </div>
</div>
<!-- JS -->
<script>
    $(document).ready(function () {
    var itemsMainDiv = ('.MultiCarousel');
    var itemsDiv = ('.MultiCarousel-inner');
    var itemWidth = "";

    $('.leftLst, .rightLst').click(function () {
        var condition = $(this).hasClass("leftLst");
        if (condition)
            click(0, this);
        else
            click(1, this)
    });

    ResCarouselSize();




    $(window).resize(function () {
        ResCarouselSize();
    });

    //this function define the size of the items
    function ResCarouselSize() {
        var incno = 0;
        var dataItems = ("data-items");
        var itemClass = ('.item');
        var id = 0;
        var btnParentSb = '';
        var itemsSplit = '';
        var sampwidth = $(itemsMainDiv).width();
        var bodyWidth = $('body').width();
        $(itemsDiv).each(function () {
            id = id + 1;
            var itemNumbers = $(this).find(itemClass).length;
            btnParentSb = $(this).parent().attr(dataItems);
            itemsSplit = btnParentSb.split(',');
            $(this).parent().attr("id", "MultiCarousel" + id);


            if (bodyWidth >= 1200) {
                incno = itemsSplit[3];
                itemWidth = sampwidth / incno;
            }
            else if (bodyWidth >= 992) {
                incno = itemsSplit[2];
                itemWidth = sampwidth / incno;
            }
            else if (bodyWidth >= 768) {
                incno = itemsSplit[1];
                itemWidth = sampwidth / incno;
            }
            else {
                incno = itemsSplit[0];
                itemWidth = sampwidth / incno;
            }
            $(this).css({ 'transform': 'translateX(0px)', 'width': itemWidth * itemNumbers });
            $(this).find(itemClass).each(function () {
                $(this).outerWidth(itemWidth);
            });

            $(".leftLst").addClass("over");
            $(".rightLst").removeClass("over");

        });
    }


    //this function used to move the items
    function ResCarousel(e, el, s) {
        var leftBtn = ('.leftLst');
        var rightBtn = ('.rightLst');
        var translateXval = '';
        var divStyle = $(el + ' ' + itemsDiv).css('transform');
        var values = divStyle.match(/-?[\d\.]+/g);
        var xds = Math.abs(values[4]);
        if (e == 0) {
            translateXval = parseInt(xds) - parseInt(itemWidth * s);
            $(el + ' ' + rightBtn).removeClass("over");

            if (translateXval <= itemWidth / 2) {
                translateXval = 0;
                $(el + ' ' + leftBtn).addClass("over");
            }
        }
        else if (e == 1) {
            var itemsCondition = $(el).find(itemsDiv).width() - $(el).width();
            translateXval = parseInt(xds) + parseInt(itemWidth * s);
            $(el + ' ' + leftBtn).removeClass("over");

            if (translateXval >= itemsCondition - itemWidth / 2) {
                translateXval = itemsCondition;
                $(el + ' ' + rightBtn).addClass("over");
            }
        }
        $(el + ' ' + itemsDiv).css('transform', 'translateX(' + -translateXval + 'px)');
    }

    //It is used to get some elements from btn
    function click(ell, ee) {
        var Parent = "#" + $(ee).parent().attr("id");
        var slide = $(Parent).attr("data-slide");
        ResCarousel(ell, Parent, slide);
    }

});
</script>


{% endblock %}

final_project/movies/templates/movies/m_cre_upd.html
{% extends 'base.html' %}
{% load bootstrap4 %}

{% block content %}
<div class='container'>
    {% if request.resolver_match.url_name == 'movie_create' %}
        <h2 class='mt-5 text-info text-center'>새 글쓰기</h2>
    {% else %}
        <h2 class='mt-5 text-info'>수정하기</h2>
    {% endif %}
    <form action="" method="POST">
        {% csrf_token %}
        {% bootstrap_form form %}
        <div class='text-center'>
        <button class='btn-lg btn-primary mb-5'>submit</button>
        </div>    
    </form>
</div>
{% endblock %}

final_project/movies/templates/movies/review_detail.html
{% extends 'base.html' %}
{% load bootstrap4 %}


{% block content %}
<!-- <div id='review-detail-background'> -->
<div style="background-color: black;">
    <div class="flex-left ml-5" style='padding-top: 30px;'>
            <a href="{% url 'movies:detail' movie.pk %}"><i class="fas fa-arrow-left fa-2x" style='color: tomato'></i></a>
    </div>
    <div style="margin:0 10rem">
    <div class="container">
    <!-- <div class='center-effect'> -->
        <h1 class='text-center song-font' style='color: rgba(236, 235, 235, 0.966);'>Review</h1>
        <hr style="border: solid 0.5px; color: rgba(245, 245, 245, 0.87); width:150px; margin-bottom: 40px;">
        
        <div class="container p-3">
            <div class='mb-3'>
                <h5 style='color: rgba(236, 235, 235, 0.966);'>제목 : {{review.title}}</h5>
            </div>
            <hr style="border: solid 0.3px; color: rgba(245, 245, 245, 0.582); width:100%;">
            <p style='color: rgba(255, 255, 255, 0.966); height: 200px;'>{{review.content}}</p>


            <hr style="border: solid 0.3px; color: rgba(245, 245, 245, 0.582); width:100%;"> 
            <div class='d-flex'>
                <p style='color: rgba(236, 235, 235, 0.966);' class='mr-auto'>{{review.created_at}}</p>
                {% if request.user == review.user %}
                <a href="{% url 'movies:review_update' review.movie.id review.pk %}">
                    <button class='account-button btn btn-outline-light'> 수정 </button>
                </a>
                
                <!-- 삭제하기 POST방식으로 보내기 -->
                <!-- pk순서 중요 : 순서 안지키면 오류뜸 -->
                <form action="{% url 'movies:review_delete' review.movie.id review.pk %}" method="POST">
                    {% csrf_token %}
                    <button class='account-button btn btn-outline-light mx-3'> 삭제 </button>
                </form>
                {% endif %}
            </div>
        </div>
        
        
        <form action="{% url 'movies:comment_create' review.movie.id review.pk %}" method="POST" style='margin-top: 50px;'>
            {% csrf_token %}
            {% bootstrap_form form %}
            <button class='account-button btn btn-outline-light'>댓글 작성</button>   
        </form>
        
        <hr class='mt-5' style='background-color:whitesmoke;'>

        <div style='color:rgba(236, 235, 235, 0.966)'>
        {% for comment in review.comment_set.all %}
            <div class='d-flex'> 
            <p class='mr-auto'>[{{ comment.user }}]</p>
                {% if request.user == comment.user %}
                <a href="{% url 'movies:comment_update' review.movie.id review.pk comment.pk %}">
                    <button class='account-button btn btn-outline-light p-1 mr-1 '>수정</button>
                </a>
                <form action="{% url 'movies:comment_delete' movie.pk review.pk comment.pk %}" method="POST">
                    {% csrf_token %}
                    <button class='account-button btn btn-outline-light p-1'>삭제</button>  
                </form>
                {% endif %}
                </div>
            <p style='height: 50px;'>{{ comment.content }}</p>
            <p style='font-size: small;' class='d-flex justify-content-end'>| 생성 | {{ comment.created_at }} | 수정 | {{ comment.updated_at }}</p>
            <hr style='background-color:whitesmoke;'>
        {% endfor %}
        </div>
    </div>
    </div>
</div>
{% endblock %}